﻿using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ICTPRG403_ICTPRG404_ICTPRG410.Data
{
 
    public class Repository
    {
        private string _connectionString;
        public Repository()
        {
            _connectionString = ConfigurationManager.ConnectionStrings["ICTPRG403_ICTPRG404_ICTPRG410"].ConnectionString;
        }
        
        public IEnumerable<Person> GetPeople()
        {
            var people = new List<Person>();
            using(var connection = new SqlConnection(_connectionString))
            using(var command = new SqlCommand("SELECT * FROM PEOPLE",connection))
            {
                connection.Open();
                var reader = command.ExecuteReader(); 
                if(reader.HasRows)
                {
                    while(reader.Read())
                    {
                        var person = new Person
                        {
                            Id = reader.GetInt32(0),
                            FirstName = reader.GetString(1),
                            LastName = reader.GetString(2),                          
                            Height = reader.GetDouble(3),
                            Weight = reader.GetDouble(4)
                        };
                        people.Add(person);

                    }
                }
            }
            return people; 
        }

        public int UpdatePerson(Person p)
        {
            int result = 0;
            using (var connection = new SqlConnection(_connectionString))
            using (var command = new SqlCommand())
            {
                command.CommandText = "UPDATE PEOPLE SET FirstName=@firstName,LastName=@lastName,Height=@height,Weight=@weight WHERE Id = @id";
                command.Parameters.AddWithValue("@id", p.Id);
                command.Parameters.AddWithValue("@firstName", p.FirstName);
                command.Parameters.AddWithValue("@lastName", p.LastName);          
                command.Parameters.AddWithValue("@height", p.Height);
                command.Parameters.AddWithValue("@weight", p.Weight);
                command.Connection = connection;
                connection.Open();
                result = command.ExecuteNonQuery();            
            }
            return result;
        }

        public int InsertPerson(Person p)
        {
            int result = 0;
            using (var connection = new SqlConnection(_connectionString))
            using (var command = new SqlCommand())
            {
                command.CommandText = "INSERT INTO PEOPLE (FirstName,LastName,Height,Weight) VALUES (@firstName,@lastName,@height,@weight)";
                command.Parameters.AddWithValue("@firstName", p.FirstName);
                command.Parameters.AddWithValue("@lastName", p.LastName);
                command.Parameters.AddWithValue("@height", p.Height);
                command.Parameters.AddWithValue("@weight", p.Weight);
                command.Connection = connection;
                connection.Open();
                result = command.ExecuteNonQuery();
            }
            return result;
        }

        public int DeletePerson(Person p)
        {
            int result = 0;
            using (var connection = new SqlConnection(_connectionString))
            using (var command = new SqlCommand())
            {
                command.CommandText = "DELETE FROM PEOPLE WHERE Id=@id";
                command.Parameters.AddWithValue("@id", p.Id);
                command.Connection = connection;
                connection.Open();
                result = command.ExecuteNonQuery();
            }
            return result;
        }

        public void ResetDatabase()
        {
            using (var connection = new SqlConnection(_connectionString))
            using (var command = new SqlCommand("RESET_DB", connection))
            {
                connection.Open();
                command.ExecuteNonQuery();
            }
        }
    }
}
